<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'Auth' => '\\StructType\\Auth',
            'LanguageWSDO' => '\\StructType\\LanguageWSDO',
            'AirlineWSDO' => '\\StructType\\AirlineWSDO',
            'AirportWSDO' => '\\StructType\\AirportWSDO',
            'CountryWSDO' => '\\StructType\\CountryWSDO',
            'ProvinceWSDO' => '\\StructType\\ProvinceWSDO',
            'SuperclassWSDO' => '\\StructType\\SuperclassWSDO',
            'SupplementClassTypeWSDO' => '\\StructType\\SupplementClassTypeWSDO',
            'SupplementBoardWSDO' => '\\StructType\\SupplementBoardWSDO',
            'TypeSupplementWSDO' => '\\StructType\\TypeSupplementWSDO',
            'TrainStationWSDO' => '\\StructType\\TrainStationWSDO',
            'TransferPlaceWSDO' => '\\StructType\\TransferPlaceWSDO',
            'TransferTypePlaceWSDO' => '\\StructType\\TransferTypePlaceWSDO',
            'TransferPlaceSupplierWSDO' => '\\StructType\\TransferPlaceSupplierWSDO',
            'ZoneWSDO' => '\\StructType\\ZoneWSDO',
            'RecommendedZoneWSDO' => '\\StructType\\RecommendedZoneWSDO',
            'ArticleWSDO' => '\\StructType\\ArticleWSDO',
            'ArticleTypeWSDO' => '\\StructType\\ArticleTypeWSDO',
            'ClassWSDO' => '\\StructType\\ClassWSDO',
            'FlightWSDO' => '\\StructType\\FlightWSDO',
            'ArticleIdWSDO' => '\\StructType\\ArticleIdWSDO',
            'StationWSDO' => '\\StructType\\StationWSDO',
            'DynamicPackageWSDO' => '\\StructType\\DynamicPackageWSDO',
            'ReleaseDayWSDO' => '\\StructType\\ReleaseDayWSDO',
            'CancellationFeeDefinitionWSDO' => '\\StructType\\CancellationFeeDefinitionWSDO',
            'RateTrainWSDO' => '\\StructType\\RateTrainWSDO',
            'AvailabilityRangeWSDO' => '\\StructType\\AvailabilityRangeWSDO',
            'ExternalFlightWSDO' => '\\StructType\\ExternalFlightWSDO',
            'BD_PaxWSDO' => '\\StructType\\BD_PaxWSDO',
            'BD_SuplementWSDO' => '\\StructType\\BD_SuplementWSDO',
            'BD_OfferWSDO' => '\\StructType\\BD_OfferWSDO',
            'BD_ServiceNormalWSDO' => '\\StructType\\BD_ServiceNormalWSDO',
            'BD_VoucherWSDO' => '\\StructType\\BD_VoucherWSDO',
            'BookingMinWSDO' => '\\StructType\\BookingMinWSDO',
            'RetvalAirportsDestinationsWSDO' => '\\StructType\\RetvalAirportsDestinationsWSDO',
            'TransfersWSDO' => '\\StructType\\TransfersWSDO',
            'FieldValueWSDO' => '\\StructType\\FieldValueWSDO',
            'FieldWSDO' => '\\StructType\\FieldWSDO',
            'FormFieldsWSDO' => '\\StructType\\FormFieldsWSDO',
            'FormDeparturesWSDO' => '\\StructType\\FormDeparturesWSDO',
            'FormRoutesWSDO' => '\\StructType\\FormRoutesWSDO',
            'FormZoneDestination' => '\\StructType\\FormZoneDestination',
            'FormFieldsRelationsWSDO' => '\\StructType\\FormFieldsRelationsWSDO',
            'ExternalBookingTravellerWSDO' => '\\StructType\\ExternalBookingTravellerWSDO',
            'ExternalBookingFlightWSDO' => '\\StructType\\ExternalBookingFlightWSDO',
            'ExternalBookingRemarkWSDO' => '\\StructType\\ExternalBookingRemarkWSDO',
            'ExternalBookingReferenceWSDO' => '\\StructType\\ExternalBookingReferenceWSDO',
            'ExternalBookingTicketNumberWSDO' => '\\StructType\\ExternalBookingTicketNumberWSDO',
            'ExternalBookingInfoWSDO' => '\\StructType\\ExternalBookingInfoWSDO',
            'ExternalBookingWSDO' => '\\StructType\\ExternalBookingWSDO',
            'ExternalBookingIssueTicketWSDO' => '\\StructType\\ExternalBookingIssueTicketWSDO',
            'ExternalBookingCancelTicketNumberWSDO' => '\\StructType\\ExternalBookingCancelTicketNumberWSDO',
            'ExternalBookingCancelTicketWSDO' => '\\StructType\\ExternalBookingCancelTicketWSDO',
            'ExternalBookingCancelItineraryWSDO' => '\\StructType\\ExternalBookingCancelItineraryWSDO',
            'DocumentSaleWSDO' => '\\StructType\\DocumentSaleWSDO',
            'AmadeusSalesReportWSDO' => '\\StructType\\AmadeusSalesReportWSDO',
        );
    }
}
